/**
 * リスト1: BitMapTest.java
 * グラフィクス表示をするプログラムの例．
 */
public class BitMapTest extends Thread{

    private final BitMapCanvas canvas = new BitMapCanvas();
    private final Timer t = new Timer();
    private final KeyInput k = new KeyInput();

    private int color(int i){
	switch(i){
	case 0: return BitMapCanvas.BLACK;
	case 1: return BitMapCanvas.RED;
	case 2: return BitMapCanvas.GREEN;
	case 3: return BitMapCanvas.BLUE;
	case 4: return BitMapCanvas.YELLOW;
	case 5: return BitMapCanvas.PURPLE;
	case 6: return BitMapCanvas.LIGHTBLUE;
	case 7: return BitMapCanvas.WHITE;
	}
	return BitMapCanvas.BLACK;
    }

    // スレッドとして実行されるメソッド
    public void run(){
        // 座標(100, 100)の位置にサイズ20の正方形を描画
	canvas.rect(100, 100, 20, 20, BitMapCanvas.RED, 0);
	int c0 = 0, c = 0;
        // 画面上にサイズ40の正方形を色を変えながら敷き詰める
	for(int i = 0; i < 16; i++){ // (/ 640 40)16
	    c = c0;
	    for(int j = 0; j < 12; j++){ // (/ 480 40)
		canvas.rect(40*i, 40*j, 40, 40, color(c), 1);
		c = (c + 1) & 0x7;
	    }
	    c0 = (c0 + 1) & 0x7;
	}
        // 線を描画するメソッドのテスト
	canvas.line(0, 0, 639, 479, color(7), 1);
	canvas.line(639, 0, 0, 479, color(7), 1);

        // フレームバッファ1をスクロールさせる
	int v = 0, h = 0;
	while(true){
	    canvas.set_offset(0, v, 1);
	    v = (v == 479) ? 0 : v + 1;

	    k.checkButton();
	    if(k.lb_flag_d){
		h++;
	    }else if(k.rb_flag_d){
		h--;
	    }
	    h = (h > 639)? 0 : h;
	    h = (h < 0)? 639 : h;
	    canvas.set_offset(h, 0, 0);

	    t.sleep(1); // 適当なウェイト
	}
    }
}
